/*
	ant1
	Mar 10, 93
*/

#include <graphics.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <alloc.h>
#include <dos.h>
#include <conio.h>

#include "ant.h"

int NANT = 25;			// number of ants
int NUM_STATES = 50; // number of states
int NTURNS = 900;
int mutLv = 5;
int trailLen = 75;

unsigned long ant::turn = 0;  // static ant member, number of turns pasted
unsigned int ant::round = 0;  // static ant member, number of mating cycles
Trail *ant::thead = NULL;     // static ant member, trail list head
Trail *ant::ttail = NULL;     // static ant member, trail list tail
ant *ant::head = NULL;        // static ant member, ant list head

/*
	ant::delTrails()
	Clean-up.  Delete all Trail structures alloc'ed
*/

void ant::delTrails()
{
Trail *t, *n;
t = thead;
while (t != NULL)
	{
	n = t->prev;
	delete t;
	t = n;
	}
thead = NULL;
ttail = NULL;
}

/*
	ant::insertTrail (color, drop color)
	Insert a new Trail structure into the list.
	Write the drop color to the screen.
*/

inline void ant::insertTrail(int color, int drop)
{
Trail *t;
t = new Trail;
if (t == NULL)
	{
	outtextxy (130, 100, "Out of Mem, no trail");
	exit(0); 					// atexit () takes care of cleanup
	}
t->x = x;
t->y = y;
t->color = color;

t->decayRound = turn + trailLen;
if (thead == NULL)
	{
	thead = t;
	ttail = t;
	t->prev = NULL;
	}
else
	{
	t->prev = NULL;
	thead->prev = t;
	thead = t;
	}
putpixel ((int)x,(int)y, drop);
}

/*
	ant::updateTrails()
	Check trail list, if trail is expired, restore original color.
*/

void ant::updateTrails()
{
Trail far *t, far *p;
//int yy;
t = ttail;
if (t == NULL) return;
while ((ant huge *)t != (ant huge *)thead && t->decayRound <= turn)
	{
	p = t->prev;
//	if (t->color == crap || t->color == body)
//		{
//		yy = getpixel(t->x, t->y);
//		if (yy == (int)crap)
//			putpixel (t->x, t->y, blank);
//		}
//	else if (t->color == food)
//		{putpixel(t->x, t->y, food);}
//	else
		{putpixel(t->x, t->y, t->color); }
	delete t;
	t = p;
	ttail = t;
	}
}

ant::~ant()
{
}

/*
	ant::correctXY()
	If an ant runs off the screen, do a wrap.
*/

inline void ant::correctXY()
{
if (x <= 0)
	{
	x = 638.0;       // hard coded VGA -- yes I know it's bad
	}                // but this is just a small, quick hack.
else if (x > 638)
	{
	x = 0.0;
	}
if (y <= 22)
	{
	y = 478.0;
	}
else if (y > 478)
	{
	y = 22.0;
	}
}

/*
	ant::getXY(x, y)
	Get the starting coordinate of an ant.
*/

//inline void ant::getXY(float& x, float& y)
inline void ant::getXY(fixed& x, fixed& y)
{
x = (double)(rand() % getmaxx());
//y = (float) (rand() % (getmaxy()-22) + 22);
y = (double)40;
}

/*
	randColor()
	Used to initialize the ants' state table.
*/

states randColor()
{
switch (rand() % 3)
	{
	case 0: return blank;
	case 1: return trail;
	case 2: return crap;
	}
return blank;
}

ant::ant ()
{
int r,c;
int xx;
dir = rand() % 360;

for (r = 0; r < 5; r++)
	{
	stateTab[r] = (struct st *)farmalloc (sizeof (st) * NUM_STATES);
	if (stateTab[r] == NULL)
		{
		outtextxy (130, 100, "Out of Mem, no state tab");
		exit(0); 					// atexit () takes care of cleanup
		}
	}
for (r=0; r < 5; r++)					// five rows in the state table
	{
	for (c = 0; c < NUM_STATES; c++)
		{
		xx = rand()% 3;
		switch (xx)      // set random direction changes
			{
			case 0: stateTab[r][c].dir = 0; break;
			case 1: stateTab[r][c].dir = 1; break;
			case 2: stateTab[r][c].dir = -1; break;
			}
//		stateTab[r][c].amount = rand() % 165 + 15;  // set amount of dir change
		stateTab[r][c].amount = rand() % 30 + rand() % 30;
		stateTab[r][c].state = rand() % NUM_STATES;    // randomize states
		stateTab[r][c].dropColor = randColor();
		}
	}
getXY (x, y);				// set starting coordinates
//for (r=0; r < 5; r++)   // five rows in the state table
//	{
//	for (c=0; c < NUM_STATES; c++)
//		{
//		stateTab[r][c].state = rand() % NUM_STATES;    // randomize states
 //		stateTab[r][c].dropColor = randColor();
//		}
//	}
state = 0;  //rand() % NUM_STATES;
curCell = blank;
score = 0;
round = 0;
thead = NULL;
ttail = NULL;
turn = 0;
crapCount = 0;
}

/*
	- lookup new direction
		-- find the color of pixel in current direction
		-- do a lookup
	- lookup drop cell
		-- color of cell ant is now on X last cell dropped
	- calc pixel to move to
	- oldCell = color of pixel to move to
	- update x,y
	- putpixel, new pixel and dropped cell
*/

inline static void dfixUp (int *d, st *chg)
{
if (chg->dir == 1)  // add
	{
	*d += chg->amount;
	if (*d > 359) *d -= 360;
	}
else if (chg->dir == -1)  // subtract
	{
	*d -= chg->amount;
	if (*d < 0) *d += 360;
	}
}

//static float tanTab[360];
//static float cosTab[360];
static fixed tanTab[360];
static fixed cosTab[360];
static int _ix,_iy;

/*
	ant::move()
	Calculate ant's new position.
*/

void ant::move ()
{
//float tx;
fixed tx;
int d;

switch (curCell)  // find the state number for the cell ant is currenly on.
	{
	case blank: d=0; break;
	case food: d=4; break;
	case crap: d=1; break;
	case body: d=3; break;
	case trail: d=2; break;
	default: outtextxy (50,80,"move1"); exit(20);
	}
state = stateTab[d][state].state;  // lookup new state
d = stateTab[d][state].dropColor;  // lookup new drop color

if (curCell == food)               // preserve the food area
	{
	putpixel (x, y, curCell);
	}
else if (d == crap)//stateTab[d][state].dropColor == crap)
	{
	if ( crapCount > 0)     // drop a crap cell?
		{
		crapCount--;
		if (curCell != trail && curCell != body && curCell != crap)
			insertTrail (curCell, crap);
		else //if (curCell != crap && curCell != trail && curCell != body)
			putpixel (x, y, blank);//curCell);
		}
	else                    // drop a normal trail
		{
		if (curCell == trail || curCell == crap)
			putpixel (x, y, blank); //curCell);
		else if (curCell == body)
			{
			if (oldCurCell != trail && oldCurCell != crap && oldCurCell != body)
				putpixel (x, y, oldCurCell);
			}
		else
			{
//			if (curCell != body)
				insertTrail (curCell, trail);
			}
		}
	}
else if (curCell == body)
	{
	if (oldCurCell != trail && oldCurCell != crap && oldCurCell != body)
		putpixel ((int)x, (int)y, oldCurCell);
	}
else
	{
	if (curCell == trail || curCell == crap)
		putpixel ((int)x, (int)y, blank);//curCell);
	else
		insertTrail (curCell, d);
	}
dfixUp(&dir, &stateTab[d][state]);

tx = cosTab[dir];       // cos of dir == change in x
y = y + tanTab[dir] * tx;  // tan of dir * cos of dir == change in y
x = x + tx;
correctXY();            // check for off screen conditions

_ix = (int)x;           // get pixel required read int vars (NOT bit fields)
_iy = (int)y;

oldCurCell = curCell;                  // attempt to preserve screen
curCell = (states) getpixel (_ix,_iy); // pixel we are currently on
if (curCell == food)
	{
	incScore(5);
	if (crapCount < 140)
		crapCount += 3;
	}
else if (curCell == crap)
	{
	incScore(1);
	crapCount++;
	}
putpixel (_ix,_iy,body);
}
#include <assert.h>

/*
	ant::mate (smart[], dumb[])

	Shuffle two smarts and replace a dumb.
*/

void ant::mate (ant *smart, ant *dumb)
{
int r,c, half;

assert (smart != NULL && dumb != NULL);

if ((rand() % 10) < 6)             // sort columns
	{
	half = NUM_STATES / 2;
	for (r=0; r < 5; r++)
		{
		for (c=0; c < half; c++)
			{
			dumb->stateTab[r][c] = stateTab[r][c];
			}
		}
	for (r=0; r<5; r++)
		{
		for (c=half; c < NUM_STATES; c++)
			{
			dumb->stateTab[r][c] = smart->stateTab[r][c];
			}
		}
	}                      // sort rows
else
	{
	for (r=0; r < 5; r+=2)
		{
		for (c=0; c < NUM_STATES; c++)
			{
			dumb->stateTab[r][c] = smart->stateTab[r][c];
			if (r < 4)
				{
				dumb->stateTab[r+1][c] = stateTab[r+1][c];
				}
			}
		}
	}
dumb->state = 0;      // reset offspring's state
}


inline void draw_scr()
{
cleardevice();
setcolor((int)food);
setfillstyle(SOLID_FILL, (int)food);
fillellipse (getmaxx()/2, getmaxy()/2, 150, 70);
}

/*
	setupTrig()

	Initialize trig tables cosTab and tanTab.
*/

static void setupTrig()
{
int x;
for (x=0; x < 360; x++)
	{
	cosTab[x] = cos(RAD(x));
	tanTab[x] = tan(RAD(x));
	}
}

/*
	ltTestInsert (ant **list, ant *aAnt, num ant in list)
	Test aAnt, if it has a lower score than other ants in
	list, insert it.
	(For dumb).
*/

void ltTestInsert (ant **alist, ant *i, const int num)
{
int x1;
ant *ta;

for (x1=0; x1 < num; x1++)
	{
	if (i->score < alist[x1]->score)
		{
		ta = alist[x1];
		alist[x1] = i;
		ltTestInsert (alist, ta, num);
		x1 = 1000;
		}
	}
}
/*
	gttTestInsert (ant **list, ant *aAnt, num ant in list)
	Test aAnt, if it has a higher score than other ants in
	list, insert it.
	(For smart).
*/

void gtTestInsert (ant **alist, ant *i, const int num)
{
int x1;
ant *ta;

for (x1=0; x1 < num; x1++)
	{
	if (i->score > alist[x1]->score)
		{
		ta = alist[x1];
		alist[x1] = i;
		gtTestInsert (alist, ta, num);
		x1 = 1000;
		}
	}
}

/*
	parseArgs (argc, argv)
	Set command line flags:
		-t Number of turn between mating cycles.
		-s Number of states in the state table.
		-a Number of ants.
		-h Help screen
*/

void parseArgs (int argc, char *argv[])
{
while (argc > 1)
	{
	if (argv[argc-1][0] == '-')
		{
		char buf[30];
		char *bp;
		int x = 2;
		switch (argv[argc-1][1])
			{
			case 's':
			case 'S':
				bp = &buf[0];
				while (argv[argc-1][x] != ' '  && argv[argc-1][x] != '\n'
						&& argv[argc-1][x] != '\0')
					{
					*bp = argv[argc-1][x];
					x++;
					bp++;
					}
				*bp = '\0';
				NUM_STATES = atoi (&buf[0]);
				break;
			case 'a':
			case 'A':
				bp = &buf[0];
				while (argv[argc-1][x] != ' '  && argv[argc-1][x] != '\n'
						&& argv[argc-1][x] != '\0')
					{
					*bp = argv[argc-1][x];
					x++;
					bp++;
					}
				*bp = '\0';
				NANT = atoi (&buf[0]);
				break;
			case 't':
			case 'T':
				bp = &buf[0];
				while (argv[argc-1][x] != ' '  && argv[argc-1][x] != '\n'
						&& argv[argc-1][x] != '\0')
					{
					*bp = argv[argc-1][x];
					x++;
					bp++;
					}
				*bp = '\0';
				NTURNS = atoi (&buf[0]);
				break;
			case 'h':
			case 'H':
				puts ("Ants by John Garrison\nUSAGE:  ants [-s(NUM_STATES)]\n");
				puts ("[-a(NUM_ANTS)][-t(NUMER TURNS BETWEEN MATING)]\n");
				puts ("[-m(MUTATION_LV)]\n");
				break;
			case 'm':
			case 'M':
				bp = &buf[0];
				while (argv[argc-1][x] != ' '  && argv[argc-1][x] != '\n'
						&& argv[argc-1][x] != '\0')
					{
					*bp = argv[argc-1][x];
					x++;
					bp++;
					}
				*bp = '\0';
				mutLv = atoi (&buf[0]);
				break;
			case 'l':
			case 'L':
				bp = &buf[0];
				while (argv[argc-1][x] != ' '  && argv[argc-1][x] != '\n'
						&& argv[argc-1][x] != '\0')
					{
					*bp = argv[argc-1][x];
					x++;
					bp++;
					}
				*bp = '\0';
				trailLen = atoi (&buf[0]);
				break;
			}
		}
	argc--;
	}
}

ant far **smart;	// smart ants for mating.
ant far **dumb;    // dumb ants for mating.

/*
	cleanup()
	called when exit() is called.
*/

void cleanup()
{
ant far *t;
restorecrtmode();
closegraph();
while (ant::head != NULL)
	{
	t = ant::head->next;
	delete ant::head;
	ant::head = t;
	}
farfree (smart);
farfree (dumb);
}

//#define NANT 25

main(int argc, char *argv[])
{
//const int numSmart = (int) (NANT * .2);
//const int numDumb = (int)(NANT *.1);
//ant *smart[ numSmart ], *dumb[ numDumb ];
//const nant = NANT;
int numSmart;   // sizeof smart
int numDumb;    // sizeof dumb

int turn,x,zz;
int _drv = VGA, _mode = VGAHI;
ant far *a;
char buf[110];
unsigned long Score = 0;
int errorcode;

parseArgs (argc, argv);
numSmart = (int)(NANT *.2);
numDumb = (int)(NANT *.1)+1;
smart = (ant **)farmalloc (sizeof (ant *) * numSmart);
if (smart == NULL)
	{
	puts ("Out of memory\n");
	exit (100);
	}
dumb = (ant **)farmalloc (sizeof (ant *) * numDumb);
if (dumb == NULL)
	{
	puts ("Out of memory\n");
	farfree (smart);
	exit (100);
	}
atexit(cleanup);
//initgraph (&_drv, &_mode, "c:\\tc\\bgi");
initgraph (&_drv, &_mode, "");
errorcode = graphresult();
if (errorcode != grOk)  /* an error occurred */
	{
	printf("Graphics error: %s\n", grapherrormsg(errorcode));
	exit(1);             /* return with error code */
	}
time_t _t;
time(&_t);
srand((int)_t);

draw_scr();
setfillstyle (CLOSE_DOT_FILL, LIGHTBLUE);
setcolor (EGA_YELLOW);
bar3d (0, 0, 639, 20, 639/4, 1);

setupTrig();

ant::head = new ant;      // alocate ants
a = ant::head;
if (a == NULL)
	{
	outtextxy (130, 100, "Out of Mem, no ants");
	exit(20);
	}
sprintf((char *)buf, "FSA-GA ANTS %s -- Round # %d; Score = %lu; MEM = %luK",
		  __DATE__, ant::round++, Score, coreleft()/1024);
outtextxy (5, 8, buf);
srand((unsigned) time((long near *)&_t));

for (x=1; x < NANT; x++)
	{
	a->next = new ant;
	if (a->next == NULL)
		{
		outtextxy(40,50, "Out of mem!");
		exit (9);
		}
	a = a->next;
	}
a->next = NULL;

while (!kbhit())
	{
	Score = 0;
	for (turn=0; turn < NTURNS; turn++)  // run for a while
		{
		for (a = ant::head, x = 0; x < NANT; x++)
			{
			a->move();
			a = a->next;
			}
		ant::turn++;
		ant::updateTrails();
		}
	int sopen, dopen;
	char x1;
	for (a=ant::head, x=0, sopen = 0, dopen=0;
	x < NANT && dopen < numDumb && sopen < numSmart; x++)
		{
		if (((rand() % NANT) < numSmart+1) && sopen < numSmart)
			smart[sopen++] = a;
		else if (((rand() % NANT) < numDumb+1) && dopen < numDumb)
			dumb[dopen++] = a;
		a = a->next;
		}
	for (a=ant::head, x=0; x < NANT; x++)    // score ants
		{
		if (sopen < numSmart)
			{
			smart[sopen++] = a;               // add a smart ant
			}
		else
			{
			gtTestInsert(smart, a, numSmart);   // smart full, smarter? add
			}
		if (dopen < numDumb && sopen >= numSmart)
			{
			dumb[dopen++] = a;//->next;           // add dumb ant
			}
		else if (sopen >= numSmart)
			{
			ltTestInsert (dumb, a, numDumb);  // dumb full, dumber? add
			}
		a = a->next;
		}
//	Score = 0;
	for (x=0,x1=0; x < numSmart-1; x+=2)	// mate the ants
		{
//		Score += smart[x]->score + smart[x+1]->score;
		smart[x]->mate(smart[x+1], dumb[x1++]);
		}
	for (x=0, a = ant::head; x < NANT; x++)  // calc score, reset ants
		{
		Score += a->score;
		a->score = 0;
		a = a->next;
		}
	if ((rand() % 100) <= mutLv)              // mutations 5%
		{
		zz = rand() % numDumb;
		for (x = 0; x < 5; x++)
			{
			for (x1 = 0; x1 < NUM_STATES; x1++)
				{
				if ((rand() % 100) <= mutLv)
					{
					switch (rand()%3)
						{
						case 0: dumb[zz]->stateTab[x][x1].dir = 0; break;
						case 1: dumb[zz]->stateTab[x][x1].dir = 1; break;
						case 2: dumb[zz]->stateTab[x][x1].dir = -1; break;
						}
					dumb[zz]->stateTab[x][x1].amount = rand() % 165 + 15;
					dumb[zz]->stateTab[x][x1].state = rand() % NUM_STATES;
					dumb[zz]->stateTab[x][x1].dropColor = randColor();
					}
				}
			}
		}
/*	if ((rand() % 100) < 15)
		{
		draw_scr();
		setfillstyle (CLOSE_DOT_FILL, LIGHTBLUE);
		}
*/	bar3d (0, 0, 639, 20, 639/4, 1);
	sprintf((char *)buf, "FSA-GA ANTS %s -- Round # %d; Score = %lu; MEM = %luK",
		  __DATE__, ++ant::round, Score, coreleft()/1024);
	setcolor (EGA_YELLOW);
	outtextxy (5, 8, buf);
	}
return 0;
}
